<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Admin Dashboard Template</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- overlayScrollbars -->
    <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
  </head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DEVCAMP 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Đức Hậu</a>
        </div>
      </div>

      

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="./index.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Task 45.30</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Task 45.40</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="./index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Task 45.50</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Danh sách đơn hàng</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Task 45.50</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="container jumbotron">
            <div class="row">
                <label for="select-pizza" class="col-sm-2 col-form-label">Pizza</label>
                <div class="col-sm-3">
                    <select id="select-pizza" class="form-control"></select>
                </div>
                <label for="select-status" class="col-sm-2 col-form-label">Status</label>
                <div class="col-sm-3">
                    <select id="select-status" class="form-control"></select>
                </div>
                <div class="col-sm-2">
                    <button class="btn btn-primary" id="btn-filter">Lọc</button>
                </div>
            </div>
        </div>
        <table class="table text-center table-striped" id="table-orders">
            <thead>
                <tr>
                    <th scope="col">Order ID</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
      </div><!-- /.container-fluid -->
    </section>

  
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>IronHack &copy;2022 <a href="https://adminlte.io">DEVCAMP 120</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 0.0.1
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- overlayScrollbars -->
  <script src="plugins/overlayScrollbars/js/jquery.overlayScrollbars.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>

<script>
    "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
const gEND_ROW_TABLE = -1;
// hằng số số thứ tự các cột
const gCOLUMN_ORDER_ID = 0;
const gCOLUMN_SIZE = 1;
const gCOLUMN_PIZZA_TYPE = 2;
const gCOLUMN_DRINK_TYPE = 3;
const gCOLUMN_PRICE = 4;
const gCOLUMN_NAME = 5;
const gCOLUMN_PHONE = 6;
const gCOLUMN_STATUS = 7;
const gCOLUMN_ACTION = 8;

const gCOL_NAME = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien",
    "hoTen", "soDienThoai", "trangThai", "action"];

var gPizzaData = {
    pizzas: [],
    filterData: function (paramFilterData) {
        var vFilterData = [];
        var vPizza = "";
        var vStatus = "";
        for (var vDataIndex in this.pizzas) {
            vPizza = this.pizzas[vDataIndex].loaiPizza;
            vStatus = this.pizzas[vDataIndex].trangThai;
            if (this.pizzas[vDataIndex].loaiPizza != null) {
                vPizza = this.pizzas[vDataIndex].loaiPizza.toLowerCase();
            }
            if (this.pizzas[vDataIndex].trangThai != null) {
                this.pizzas[vDataIndex].trangThai.toLowerCase();
            }


            if ((vPizza == paramFilterData.pizzaType || paramFilterData.pizzaType == 0) &&
                (vStatus == paramFilterData.status || paramFilterData.status == 0)) {
                vFilterData.push(this.pizzas[vDataIndex]);
            }
        }
        return vFilterData;
    },
}

var gTable = $("#table-orders").DataTable({
    columns: [
        { data: gCOL_NAME[gCOLUMN_ORDER_ID] },
        { data: gCOL_NAME[gCOLUMN_SIZE] },
        { data: gCOL_NAME[gCOLUMN_PIZZA_TYPE] },
        { data: gCOL_NAME[gCOLUMN_DRINK_TYPE] },
        { data: gCOL_NAME[gCOLUMN_PRICE] },
        { data: gCOL_NAME[gCOLUMN_NAME] },
        { data: gCOL_NAME[gCOLUMN_PHONE] },
        { data: gCOL_NAME[gCOLUMN_STATUS] },
        { data: gCOL_NAME[gCOLUMN_ACTION] },
    ],
    columnDefs: [
        {
            targets: gCOLUMN_ACTION,
            defaultContent: "<button id='btn-detail' class='btn btn-success'>Chi tiết</button"
        }
    ]
});

/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
onPageLoading();

$("#btn-filter").on('click', function () {
    onBtnFilterClick();
})

$(document).on('click', "#btn-detail", function () {
    onBtnDetailClick(this);
})

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
// Hàm thực hiện khi load trang
function onPageLoading() {
    loadPizzaTypeToSelect();
    loadStatusToSelect();
    callApiToGetAllOrders();
}

// Ham xu ly su kien nut Loc click
function onBtnFilterClick() {
    // 0.
    var vFilterObj = {
        pizzaType: "",
        status: ""
    }
    // 1.
    getSelectData(vFilterObj);
    // 2.
    // 3.
    var vFilterResult = gPizzaData.filterData(vFilterObj);
    // 4.
    loadDataToTable(vFilterResult);
}

// Xu ly hien thi khi nut btn-detail duoc click
function onBtnDetailClick(paramBtnObj) {
    var vSelectIndex = $(paramBtnObj).closest("tr");
    var vTable = $("#table-orders").DataTable();
    var vRowValue = vTable.row(vSelectIndex).data();
    console.log(vRowValue);
}

/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
// hàm gọi api để lấy all orders
function callApiToGetAllOrders() {
    $.ajax({
        url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: "json",
        success: function (responseText) {
            gPizzaData.pizzas = responseText;
            console.log(gPizzaData.pizzas);
            loadDataToTable(gPizzaData.pizzas)
        },
        error: function (errorContent) {
            console.assert(errorContent);
        }
    });
}
// Load OrderData to table
function loadDataToTable(paramData) {
    gTable.clear();
    gTable.rows.add(paramData);
    gTable.draw();
}
// Load pizza-select-option
function loadPizzaTypeToSelect() {
    var vPizzaSelectElem = $("#select-pizza");
    $("<option/>", {
        value: 0,
        text: "Chọn loại Pizza"
    }).appendTo(vPizzaSelectElem);

    $("<option/>", {
        value: "Bacon",
        text: "Thịt hun khói"
    }).appendTo(vPizzaSelectElem);
    $("<option/>", {
        value: "Seafood",
        text: "Hải sản"
    }).appendTo(vPizzaSelectElem);
    $("<option/>", {
        value: "Hawaii",
        text: "Pizza Hawaii"
    }).appendTo(vPizzaSelectElem);
}
// Load status-select-option
function loadStatusToSelect() {
    var vStatusElem = $("#select-status");
    $("<option/>", {
        value: 0,
        text: "Chọn trạng thái"
    }).appendTo(vStatusElem);
    $("<option/>", {
        value: "open",
        text: "Open"
    }).appendTo(vStatusElem);
    $("<option/>", {
        value: "cancel",
        text: "Cancel"
    }).appendTo(vStatusElem);
    $("<option/>", {
        value: "confirmed",
        text: "Confirm"
    }).appendTo(vStatusElem);
}
// Get Select Option
function getSelectData(paramFilterObj) {
    // 1.
    var vPizza = $("#select-pizza").val().toLowerCase();
    var vStatus = $("#select-status").val().toLowerCase();
    // 2.
    paramFilterObj.pizzaType = vPizza;
    paramFilterObj.status = vStatus;
}
</script>
</body>
</html>
